\documentclass[10pt,conference]{IEEEtran}
\IEEEoverridecommandlockouts
% The preceding line is only needed to identify funding in the first footnote. If that is unneeded, please comment it out.
\usepackage{cite}
\usepackage{amsmath,amssymb,amsfonts}
\usepackage{algorithmic}
\usepackage{graphicx}
\usepackage{textcomp}
\usepackage{xcolor}
\usepackage{tcolorbox}
\usepackage[inline]{enumitem}
\usepackage{float}
\usepackage{tikz}
\usepackage{mathtools}
% \usepackage[singlespacing]{setspace} 
% \setstretch{1.01352}
\DeclarePairedDelimiter{\ceil}{\lceil}{\rceil}

\usetikzlibrary{positioning, fit, calc, shapes, arrows}
\usepackage[underline=false]{pgf-umlsd}
\newcommand\encircle[1]{%
  \tikz[baseline=(X.base)]
    \node (X) [draw, shape=circle, inner sep=0, fill=black, text=white] {\strut #1};%
}
\graphicspath{{image/}}
\def\BibTeX{{\rm B\kern-.05em{\sc i\kern-.025em b}\kern-.08em
    T\kern-.1667em\lower.7ex\hbox{E}\kern-.125semX}}
\begin{document}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% visible editing comments in the PDF, per writer.

\newboolean{ShowComments}
\setboolean{ShowComments}{true}  % change to true to show remaining colorful author comments.
                                 % change to false to hide all author comments.
\ifthenelse{\boolean{ShowComments}}%
	{
		\newcommand{\ColorComment}[3]{%
				{\colorbox{#1}{\color{white}   \textsf{\textbf{#2}}} \textcolor{#1}{#3}}}%  Colorful box, initials, phrase
        \newcommand{\TR}[1]{\textcolor{Red}{#1}}
        \newcommand{\TB}[1]{\textcolor{Red}{#1}}
        \newcommand{\TO}[1]{\textcolor{Red}{#1}}
	}%
	{
		\newcommand{\ColorComment}[3]{}%  Do nothing at all
        \newcommand{\TR}[1]{#1}
        \newcommand{\TB}[1]{#1}
        \newcommand{\TO}[1]{#1}
	}%
%This commands are defined for commenting the paper
%David
\definecolor{dgucolor}{rgb}{0,0.5,0}\newcommand{\david}[1]{\ColorComment{dgucolor}{david}{#1}}
%Dirk
\definecolor{dotcolor}{rgb}{0.5,0.9,0}\newcommand{\dirk}[1]{\ColorComment{dotcolor}{dirk}{#1}}
%Joerg
\definecolor{jotcolor}{rgb}{0.5,0.1,0}\newcommand{\joerg}[1]{\ColorComment{jotcolor}{joerg}{#1}}

\title{Proliferation of the Service-centric Distributed Consensus Model and its Impact on Ethereum}

\author{
\IEEEauthorblockN{David Guzman}
\IEEEauthorblockA{
\textit{Technical University of Munich}\\
Munich, Germany \\
david.guzman@tum.de}

\and
\IEEEauthorblockN{Dirk Trossen}
\IEEEauthorblockA{\textit{Huawei Technologies} \\
% \textit{Huawei Technologies}\\
Munich, Germany \\
dirk.trossen@huawei.com}

\and
\IEEEauthorblockN{Trinh Viet Doan}
\IEEEauthorblockA{\textit{Technical University of Munich}\\
Munich, Germany \\
trinhviet.doan@in.tum.de}

\and
\IEEEauthorblockN{Joerg Ott}
\IEEEauthorblockA{\textit{Technical University of Munich}\\
Munich, Germany \\
ott@in.tum.de}

}

\maketitle

\begin{abstract}
In distributed consensus systems (DCSs), a single peer exposes functionality to other peers to agree on a shared state for a computational problem, such as for cryptocurrencies and distributed file systems. We observe, however, that this original, peer-centric model has evolved towards deploying several peers at a single network location, thus exposing the same DCS services many times, driven by the fees and rewards that can be gained by doing so. We refer to this trend as the \textit{service-centric model} and provide in our paper evidence for this trend, its growth, and its impact on DCS operations, using empirical observations in the Ethereum system. Specifically, we shed light on the opposing observations of increasing reliance on highly available cloud infrastructures and large numbers of non-reachability events in the DCS. We provide recommendations on how to tackle this impact through changes to the Ethereum platform and identifier generation, believing that those recommendations and our empirical observations provide useful insights for building resilient and bias-free DePIN platforms.

\end{abstract}

% \begin{IEEEkeywords}
% distributed systems, peer-to-peer, networking
% \end{IEEEkeywords}
\section{Introduction}\label{sect:introduction}

%purpose of the DCS
The vision of a distributed consensus system (DCS) foresees participating peers to achieve consensus over a shared state in a continuous computation, where the system does not exhibit bias towards the location or nature of the peer in the participating infrastructures in which the peers are deployed. More so, Bitcoin \cite{Nakamoto2008}, Ethereum \cite{Wood2014}, Stellar \cite{Lokhava2019}, Chia \cite{Cohen2019}, and Algorand \cite{Dimitri2022}, among others, explore a permissionless or open membership character for participating in such DCS, imposing thus less stringent requirements on the peers.

Participation in the DCS is motivated by benefits from fees and rewards, i.e., peers collect fees for committing and prioritizing changes to the shared state \cite{Cortes-Goicoechea2023}, while the DCS rewards peers for maintaining a coherent state \cite{Nakamoto2008}.

This vision aligns well with a decentralized physical infrastructure (DePIN) \cite{Ballanties2023}, where the participating physical resources equal peers in a DCS, with tokens used as rewards for provisioning and using the decentralized resources.

However, as our main contribution, we outline in this paper that the vision of complete decentralization in DCSs needs to be more effectively skewed by the realities of deploying peers on the Internet. More specifically, we show through empirical evidence that only very few major cloud-based infrastructures contribute to the consensus-making process, thus opening the potential for bias and impacting the resilience of the overall distributed system. The critical issue is that despite highly available peers in the DCS, achieved through deploying them in highly available cloud provider networks, reachability within the DCS remains an issue.

We then derive two concrete recommendations as our second contribution, which not only allow for improving existing DCS platforms through specific changes to their software basis but also consider them in the design for the platforms that form the control plane for the emerging DePIN.

For this, we start outlining in Section \ref{sect:trend} the observed trend away from deploying single peers in a DCS towards deploying many service endpoints within highly available cloud infrastructures. We then show in Section \ref{sect:model} the empirical observations for this trend in the now-deployed Ethereum system, aligning with previously reported results from other DLT systems \cite{Tumas2023,Grundmann2022}. Through this, we explain in Section \ref{sect:impact} the seemingly contradicting observation of unreachability of highly available peers in the DCS, leading us to concrete recommendations in Section \ref{sect:recommendations} to counter the impact of the observed infrastructure consolidation on the DCS, before concluding in Section \ref{sect:conclusion}.

\section{Move to a Service-centric DCS}\label{sect:trend}

In order to deploy a peer, users download and launch applications, where those applications realize the functionality required to receive and diffuse a shared state. As an example for Ethereum, software such as geth \cite{goethereum, goethereum-architecture}, open Ethereum \cite{openethereum}, erigon \cite{erigon}, nethermind \cite{nethermind}, prysm \cite{prysm}, and others, provide functionalities, e.g., gossiping, through an application, as illustrated in Fig. \ref{fig:peer-centric-architecture}-a, being geth the dominating application in the Ethereum system \cite{ethereum-client-diversity}.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.24\textwidth]{image/peer-centric-architecture}
  \includegraphics[width=0.24\textwidth]{image/peer-centric-eth-naming}
  \caption{(a) Peer-centric model and (b) its evolution through app. replication}
  \label{fig:peer-centric-architecture}
\end{figure}

% #realization of application
This application actively probes for peers to build and replenish a collection of successful connections, as outlined in \cite{Guzman2022}.
The required lookups and connection functionalities run in a single IP-based endpoint, i.e., a peer exposes the overall functionality only once to the network.
Thus, realizing a functionality per peer, we refer to this as the \textit{peer-centric model} for the rest.

Contrasting this peer-centric view of a DCS, one can look at the functionality of a peer as providing a \textit{service} to other peers.
More so, aligned with known concepts of service provisioning, that service may be exposed by more than one \textit{service instance}.
In Ethereum, this is achieved through running multiple replicas in a single peer; we label this mode of DCS provisioning as following a \textit{service-centric model}.

%purpose of multiple instances
Motivated by boosting rewards and fees, peers join to partake in the DCS with several running service instances, as in Fig. \ref{fig:peer-centric-architecture}-b in order to increase the likelihood of earning rewards and seizing more transaction requests \cite{Cortes-Goicoechea2023}.
This tendency, shown in Fig. \ref{fig:peer-centric-architecture}-b, denotes the evolution of the peer-centric, original deployment to that of deploying several peer services in one network location.

\section{Evidence for the Service-Centric Trend}\label{sect:model}

Let us dive deeper into the evolution from the peer-centric model, a growing divergence between peers and services, a service-oriented trend driven by profits.

%%purpose for tuned several service instances
Fees and rewards are \textbf{drivers} that motivate a service-oriented trend.
Peers tune service instances to boost their participation in consensus building.
Any peer joining the DCS may run several active instances to increase participation and, therefore, the probability of earning rewards; this is because the DCS aims to equally distribute dividends among the running services in the system \cite{Wood2014, Nakamoto2008}.

%approach: mechanisms
Peers realize particular \textbf{mechanisms} to expand their participation in the DCS.
These mechanisms include configuring aggressive fanouts, short-timing pool replenishments \cite{Zhou2023}, and exposing more than one service instance.

%purpose: a collection of connections
First, a pool configured with an aggressive fanout aims at diffusing a distributed shared state with low latency by reaching more peers than the default \cite{Zhou2023, Guzman2022}. Peers configuring a higher than the default number of endpoints to grow their pool degrees realize that aggressive fanout.
In Ethereum, for example, peers set more than the default pool size of fifty endpoints.
This high peer degree distribution is reported in \cite{Grundmann2022, Muehle2021} for Bitcoin, in \cite{Gao2019} and \cite{Kim2018} as node degree for Ethereum, and in \cite{Tumas2023} for XRP Ledger.

Second, faster pool replenishment seeks to diversify the pool fanout to reach more peers in shorter periods while diffusing the distributed shared state. For example, the default timeout for establishing a new connection in Ethereum is fifteen seconds \cite{goethereum}.

Lastly, exposing many service instances per peer increases partaking in the distributed state consensus.

In Ethereum, application replication per-peer realizes this service instance exposure, realizing consensus participation and state diffusion as a service-centric model.

We contrast the peer-centric against the service-centric model and observe the discrepancy between the number of peer IP addresses and service instances to introduce the \textbf{empirical evidence for the trend}.

\begin{figure}[ht]
  \centering
  % \includegraphics[width=0.39\textwidth]{image/cumsum_peer_service}
  \includegraphics[width=0.49\textwidth]{image/cumsum_peer_service-gray}
  \caption{The Service-centric Trend}
  \label{fig:cumsum_peer_service}
\end{figure}
%trend starts : 79920 peers
% [1] "Services: 185576"
% [1] "Active Services: 152287"
% [1] "Succ. Services: 64557"
% [1] "IPs: 115308"
% [1] "Active IPs: 99231"
% [1] "Succ IPs: 46591"
% [1] "Virtual peers: 70268"

%99231*100/115308=86
%79920*100/115308
% 1771*100/115308
Fig. \ref{fig:cumsum_peer_service} highlights the degree of the current divergence between service instances and peers, using empirical evidence from $\approx 115k$ different peers identified by IP addresses.
These peers were discovered in campaigns between 2022 and 2023, as detailed in \cite{Trossen2021, Guzman2022}.
In these campaigns, $86\%$ peers actively provided $\approx 185.5k$ service instances.
This discrepancy allows us to elaborate on the starting gap at $79.9k$ peers, meaning that $69\%$ peers find a one-to-one correspondence between an IP address and a service instance ID.
This gap grows non-linearly to points of reachability with a maximum degree of exposing $\approx1.7k$ service instances in a peer.

\begin{figure}[ht]
  \centering
  % \includegraphics[width=0.39\textwidth]{image/histogram_peer_service}
  \includegraphics[width=0.49\textwidth]{image/histogram_peer_service-gray}
  \caption{The Growth in the Service-centric Trend}
  \label{fig:histogram_peer_service}
\end{figure}
% IP              services
%    <fct>              <int>
%  1 23.88.70.212        1771
%  2 65.108.65.85         682
%  3 123.1.225.100        666
%  4 194.195.126.82       659
%  5 139.59.44.178        641
%  6 172.104.70.146       624
%  7 178.62.1.187         622
%  8 139.177.188.111      616
%  9 18.142.232.3         595
% 10 44.225.220.188       566
In Fig. \ref{fig:histogram_peer_service}, we show that this growth of the service-centric trend has followed a long tail distribution.
This tailed growth means that few peers run many instances, and many run more than a single instance.
For example, a single peer hosts $1771$ instances, and around $175$ peers provide between two and three service instances.
Indeed, a few dedicated, well-known infrastructures aid this behavior, as explained in the following.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.29\textwidth]{image/bar_peers_services_isp-gray}
  \includegraphics[width=0.175\textwidth]{image/matrix_peers_services_isp}
  \caption{(a) Infrastructures hosting Peers and Instances, and (b) its Traffic Concentration on a Day Time relative to CET Time sharing the same y-axis }
  \label{fig:bar_peers_services_isp}
\end{figure}
%PEERs
% isp peers  per_peer
% 1:                     Hetzner Online GmbH 10923 9.6435855
% 2:                Amazon Technologies Inc.  9988 8.8181024
% 3:                        DigitalOcean LLC  6003 5.2998667
% 4:               Amazon Data Services NoVa  5976 5.2760292
% 5:                            Contabo GmbH  5756 5.0817979
% 6:                              Google LLC  3749 3.3098784
% 7: China Mobile Communications Corporation  3507 3.0962240
% 8:                         Amazon.com Inc.  3158 2.7881024
% 9:              Amazon Data Services Japan  3015 2.6618521
% 10:                                IPXO LLC  2289 2.0208887
% 11:    Amazon Data Services Ireland Limited  2064 1.8222430
% 12:          Amazon Data Services Singapore  1638 1.4461405
% 13:                                 OVH SAS  1490 1.3154758
% 14:                 Amazon Data Services UK  1468 1.2960527
% 15:                           A100 ROW GmbH  1360 1.2007028
% 16:        Comcast Cable Communications LLC  1308 1.1547935
% 17:         AWS Asia Pacific (Seoul) Region  1302 1.1494963
% 18:                   Microsoft Corporation  1037 0.9155359
% 19:                      Vultr Holdings LLC   908 0.8016457
% 20:              Charter Communications Inc   887 0.7831054

% sum(head(log_isp,10)$per_peer)
% [1] 47.99

%SERVICES
% isp peers  per_peer
% 1:                     Hetzner Online GmbH 23851 21.057325
% 2:                        DigitalOcean LLC 19534 17.245976
% 3:                Amazon Technologies Inc. 12568 11.095906
% 4:               Amazon Data Services NoVa  9391  8.291029
% 5:                            Contabo GmbH  8693  7.674786
% 6:                              Google LLC  5295  4.674795
% 7: China Mobile Communications Corporation  4893  4.319881
% 8:              Amazon Data Services Japan  4609  4.069146
% 9:                                 OVH SAS  4503  3.975562
% 10:                         Amazon.com Inc.  4335  3.827240
% 11:                              Linode LLC  4104  3.623297
% 12:                              OVH US LLC  2866  2.530305
% 13:          Amazon Data Services Singapore  2560  2.260146
% 14:    Amazon Data Services Ireland Limited  2441  2.155085
% 15:                                IPXO LLC  2292  2.023537
% 16:                   Microsoft Corporation  2239  1.976745
% 17:                 Amazon Data Services UK  2138  1.887575
% 18:                     DigitalOcean London  1753  1.547671
% 19:                           A100 ROW GmbH  1751  1.545905
% 20:                       Hetzner Online AG  1746  1.541490

% sum(head(log_isp_serv,10)$per_peer)
% [1] 86.23165

% Rely on infrastructure 1000/3795
The drivers and mechanisms previously outlined push the peers to seek highly available and reliable infrastructures.
Hence, causing, as an orthogonal effect, a noticeable \textit{infrastructure concentration}.
Similar results for concentration have also been reported in \cite{Tumas2023} for XRP Ledger and in \cite{Grundmann2022} for Bitcoin.
Fig. \ref{fig:bar_peers_services_isp}-a presents this degree of accumulation based on an IP address to autonomous system (AS) translation \cite{IpLocation2023}.
Here, we consider an AS an infrastructure; it includes cloud providers, Internet service providers (ISPs), and hyperscalers identified by an AS number.
With this in mind, we present the results for the top twenty most densely populated infrastructures.
We found that $47.9\%$ of the peers rely on ten out of $3795$ infrastructures. But, when looking at the service instance distribution, we observe that $86.2\%$ of the system instances run on the ten most influential infrastructures, with $21\%$ of the instances running in the top infrastructure.
Thus, \textit{more than half of the system relies on less than ten infrastructures, $0.26\%$ of all infrastructure providers}.

Intuitively, most instances in the main concentrated infrastructures generate \textit{concentrated traffic}.
Fig. \ref{fig:bar_peers_services_isp}-b characterizes the intensity of this traffic for each infrastructure as the percentage of requests a passive probe, i.e., a node, receives from the entire DCS. For example, during the entire measuring campaign of a passive probe in the DCS, the infrastructure ATI generated $21\%$ of the whole traffic of the DCS, with approximately $1\%$ of the requests of the entire DCS each hour, and HOGH generated $4.89\%$ of the traffic in the Ethereum system.
Notice, first, that more service instances do not necessarily lead to more traffic due to the tuned replenishment mechanisms detailed in Appendix \ref{app:b}.
Second, high intensity is concentrated in the top most populated infrastructures, with the second foremost provider generating the most traffic, $21.1\%$ request out of the entire DCS.
% Third, service instances generate traffic throughout the day on a regular basis, as shown in Fig. \ref{fig:bar_peers_services_isp}-b along the x-axis.

Furthermore, service instances generate daily traffic, as shown in Fig. \ref{fig:bar_peers_services_isp}-b along the x-axis.
Notice that service instance churning in these infrastructures is negligible to absent. This results as well from the economic driver outlined before.
Moreover, we infer from the service traffic across the daytime and the hosting service that service instances are highly available: the traffic density across the day is profiled without gaps,
and infrastructures such as HOGH and ATI in Fig. \ref{fig:bar_peers_services_isp} run $32\%$ of the instances in the system and offer the availability of $99.9\%$ \cite{Hetzner2021} and $99.99\%$ \cite{AmazonSLA} respectively.
But, \textit{even though highly available infrastructures support DCS instances, there are still issues with service reachability}.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.49\textwidth]{image/ecdf_traffic_isp}
  \caption{ECDF for the Percentage of Traffic Generated by an Infrastructure }
  \label{fig:ecdf_traffic_isp}
\end{figure}

%TRAFFIC BY PEER
% isp                                  incoming in_perc
% <chr>                                   <int>   <dbl>
% 1 Amazon Technologies Inc.               789389   21.1
% 2 Amazon Data Services NoVa              745236   19.9
% 3 Amazon Data Services Ireland Limited   443507   11.8
% 4 DigitalOcean LLC                       199778    5.33
% 5 Amazon.com Inc.                        194202    5.18
% 6 Hetzner Online GmbH                    183372    4.89
% 7 Amazon Data Services Japan             150988    4.03
% 8 OVH SAS                                 63204    1.69
% 9 Contabo GmbH                            63165    1.69
% 10 Google LLC                              62836    1.68

% sum(head(traffic_log,10)$in_perc)
% [1] 77.26837

Moreover, when looking at the entire system as in Fig. \ref{fig:ecdf_traffic_isp}, the top ten populated infrastructures generate approximately $77.2\%$ of the total traffic in the system. The rest of the infrastructures produce less than $1\%$ of the traffic in the DCS.

\section{Impact on the Ethereum Network}\label{sect:impact}

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.49\textwidth]{image/hosted_peer_model_error}
  \caption{Incoming (IN) and outgoing (OUT) service relation establishments}
  \label{fig:hosted_peer_model_error}
\end{figure}

Before diving into the impact and issues, let us outline the communication pattern for establishing service relations.

Discovery and pool establishment are part of a service relation building, as described in \cite[Section 2.2]{Guzman2022} and \cite[Section 2]{Kim2018}.
These procedures are standard among instances in the DCS and categorized by the instance \textit{initiator} into outgoing (OUT) and incoming (IN) relations.
In Fig. \ref{fig:hosted_peer_model_error}, \encircle{1} is an OUT relation, and \encircle{3} an IN relation.
The discovery populates a local list with tuples $(ip:id)$ by sending and receiving messages with neighboring service instances \cite{Maymounkov2002}.
For example, $(ip_4:port_4:id_4)$ may discover $(ip_1:id_1)$ through $(ip_3:port_3:id_3)$, as in \encircle{2}.
The discovered list is tested for peer reachability and then randomized to establish an OUT relation, and since the remote peers are executing the same pattern, IN relations are expected.
In Ethereum, an IN relation establishment includes a TCP connection establishment, security handshake, capability handshake, and checkpoint validation \cite{Guzman2022, Kim2018}.
These IN relations are the majority and shape the impact of reachability in the DCS \cite{Kim2018}.

Reachability affects the system's \textbf{resilience}, i.e., survivability, of the network.
Under failures, infrastructure concentration represents a shortcoming in the system.
A connectivity failure to an infrastructure such as HOGH will compromise $21\%$ of the system.
Indeed, a connectivity failure in the top ten infrastructures will undoubtedly affect $86.2\%$ of the system. However, failures in infrastructures such as HOGH and ATI seem unlikely since their average network availability is $99.9\%$ \cite{Hetzner2021} and $99,99\%$ \cite{AmazonSLA}, respectively.

We outline how the service unreachability, accounting for $87\%$ of issues out of all communication trials, impacts these infrastructures, also reported as $90\%$ in \cite{Guzman2022}, and $93.98\%$ in \cite{Kim2018}.
Out of the $87\%$ of reachability issues, $\approx 63\%$ are disconnections due to oversubscribed pools, $13\%$ of the problems are security handshake errors, and the rest comprises capability and checkpoint validations.
The oversubscribed disconnection is due to instances reaching its IN and OUT connection limits and denying further requests (too many peers in \cite{Kim2018}). The security handshake errors relate to the service security context establishment (disconnects in \cite{Kim2018}).

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.49\textwidth]{image/bar_peer_serv_reachability_isp}
  \caption{Reachability issues spread along the DCS }
  \label{fig:reachability}
\end{figure}

In Fig. \ref{fig:reachability}, we illustrate the high percentage of \textbf{service reachability} issues impacting the entire system.
The reachability issues are widely spread in the system, meaning that any passive probe at any geographical location will experience the same reachability issues from the entire DCS.
Indeed, a service instance encounters disconnects proportionally to the degree of the infrastructure hosting.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.49\textwidth]{image/correlation_reachability_service_isp}
  \caption{Correlation for \% Non-reachable against \% Instances per Infrastructure}
  \label{fig:correlation_reachability_service_isp}
\end{figure}

This proportion of disconnections holds for more extensive hosting degree infrastructures, as shown in Fig. \ref{fig:correlation_reachability_service_isp}, meaning that the more services are concentrated in an infrastructure, the more issues a peer finds. For example, ATI hosting 9988 peers with 12568 services exhibits $\approx 10\%$ out of $87\%$ of the reachability issues. In Fig. \ref{fig:correlation_reachability_service_isp}, this correlation is biased due to the tuning mechanisms, e.g., short-timed replenishment, outlined before and detailed in Appendix \ref{app:b}.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.24\textwidth]{image/bar_outgoing_error_rlpx-gray}
  \includegraphics[width=0.24\textwidth]{image/bar_incoming_error_rlpx-gray}
  \caption{(a) Outgoing and (b) Incoming Service Reachability Issues}
  \label{fig:bar_incoming_error_rlpx}
\end{figure}

As stated before, reachability issues are due to pool oversubscription and handshake issues.
We detail these handshake issues for OUT and IN relations in Fig. \ref{fig:bar_incoming_error_rlpx}.

The handshake for an OUT relation towards a remote instance requires a single remote point of reachability, i.e., a single IP address, as in \encircle{1} in Fig. \ref{fig:hosted_peer_model_error}.
However, if the response to this OUT request performs the latest used (virtual) instance through, e.g., point of reachability $(ip_2:port_2:\_)$ in Fig. \ref{fig:hosted_peer_model_error} a host peer with many virtual service instances, it results in unsolicited responses. The unsolicited responses lead to an unexpected size of a message.
The unexpected messages during handshakes cause exceptions where the application is not able to create a further response message, write exception, the application is not able to match a message in a protocol, read exception, or the application can not decode a response message, end of file (EOF) exception, in Fig. \ref{fig:bar_incoming_error_rlpx}-a. Fig. \ref{fig:bar_incoming_error_rlpx}-a and Fig. \ref{fig:bar_incoming_error_rlpx}-b differ since they are logs for an outgoing service establishment and an incoming service relation, respectively.

Furthermore, IN relation issues in Fig. \ref{fig:bar_incoming_error_rlpx}-b include $30\%$ EOF errors due to decoding packets from unsolicited responses during handshakes \cite{goethereum}, $3\%$ read issues, and $65.9\%$ from a \textbf{security context mismatch}.

More specifically, the service security context mismatch is due to the IP-centric lookup of a service relation. For example, if $(ip_1,id_1)$ is discovered by a neighbor service instance sharing the same IP-based endpoint, as in \encircle{2} in Fig.\ref{fig:hosted_peer_model_error}.
The local instance identifies the relation by the remote IP address $ip_{4}$ and loads a mismatched public key $id_{1}$; hence, the tuple for the remote endpoint is $(ip_4, id_{3})$ causing a message decryption exception that results in the high percentage of the service security context mismatch.

The high percentage of issues for IN relations matches the previous empirical observations in Section \ref{sect:model} of the service-centric model, where single IP endpoints host thousands of service instances. It is also worth noting that the reported reachability issues are given for a single probe crawling the DCS by binary distances through the system IDs. These issues are expected for the entire DCS, including the so-called execution and consensus layer \cite{ethereum-client-diversity}. Hence, \textit{the observed issues are pervasive in the DCS and prone to continuously increase due to the service-centric trend.}

% > rtt%>%group_by(V10)%>%summarize(n=n()*100/nrow(rtt))
% # A tibble: 7 × 2
%   V10                                 n
%   <fct>                           <dbl>
% 1 error-checkpoint           63.4
% 2 error-checkpoint-handshake  3.29
% 3 error-p2p                   7.87
% 4 error-rlpx                 12.6
% 5 setupconn                  12.9
% 6 tried                       0.00203
% 7 error-devp2p                0.0000239
% > rtt[V10=='error-checkpoint']%>%group_by(V15)%>%summarize(n=n()*100/nrow(rtt))
% # A tibble: 3 × 2
%   V15                    n
%   <fct>              <dbl>
% 1 "err=\"already"  0.0233
% 2 "err=\"server"   0.00278
% 3 "err=\"too"     63.3
% > rtt[V10=='error-checkpoint-handshake']%>%group_by(V15)%>%summarize(n=n()*100/nrow(rtt))
% # A tibble: 4 × 2
%   V15                     n
%   <fct>               <dbl>
% 1 "err=\"already" 0.0000957
% 2 "err=\"server"  0.000574
% 3 "err=\"too"     0.107
% 4 "err=\"useless" 3.18
% > rtt[V10=='error-p2p']%>%group_by(V15)%>%summarize(n=n()*100/nrow(rtt))
% # A tibble: 6 × 2
%   V15                       n
%   <fct>                 <dbl>
% 1 "err=\"already"    0.000263
% 2 "err=\"disconnect" 2.62
% 3 "err=\"invalid"    0.00589
% 4 "err=\"read"       0.167
% 5 "err=\"too"        4.72
% 6 "err=EOF"          0.358
% > rtt[V10=='error-rlpx']%>%group_by(V15)%>%summarize(n=n()*100/nrow(rtt))
% # A tibble: 5 × 2
%   V15                        n
%   <fct>                  <dbl>
% 1 "err=\"ecies"      7.53
% 2 "err=\"read"       0.511
% 3 "err=\"unexpected" 0.000981
% 4 "err=EOF"          4.53
% 5 "err=\"write"      0.0000239
% V15                       n
%   <fct>                 <dbl>
% 1 "err=\"ecies"      65.9
% 2 "err=EOF"          30.8
% 3 "err=\"read"        3.26
% 4 "err=\"unexpected"  0.00656

%EOF is thrown
% crypto.go
% 218 func readASCII(buf []byte, r *bufio.Reader) (n int, err error)

Finally, even though we did not conclude on the centralization of the system, we still describe how the system resilience depends on only $0.26\%$ of all infrastructures. The service instance control may be decentralized, but its concentration represents a hazard for network resilience \cite{Mcfadden2023}.
Moreover, the network's resilience is affected by the concentration of service instances and a high percentage of pervasive unreachability issues of service relations.
% This unreachability is rooted in the initial randomized communication design, e.g., oversubscribed pools, and the peer-centric model, e.g., security context mismatch. These communication issues are due to the continuous evolution of how peers expose functionality to the network, the peer-centric trend.

\section{Recommendations}\label{sect:recommendations}

Our observations in the previous sections lead us to specific recommendations, discussed in the following, to adjust current DCS systems and future DePIN designs.

\subsection{Service Dispatcher}

To recall, the main issue on reachability is caused by the handling of all incoming connections at one of the many peers that are launched at a single IP address, thus causing the other peers at this address to become `invisible' to the incoming connection, ultimately failing the handshake process.

% Aggressive pool fanout may be reduced and restricted, and timing for pool replenishment may be increased to decrease the disconnections caused by oversubscribed peers that deny further communication intents.
% This approach represents a tradeoff between the will to reduce shared state diffusion and consensus convergence latency towards the degree of the fanout and replenishment timing.
% The diffusion and convergence latency, however, can be considered as one for a small concentrated network, as shown by our insights, and not for an Internet-scale latency. The latter further improves the consensus convergence latency, e.g., time slotting for staking \cite{Wood2014} or time slotting for mining blocks \cite{Nakamoto2008}.
\begin{figure}[ht]
  \centering
  \includegraphics[width=0.48\textwidth]{image/service_dispatcher}
  \caption{Service Dispatcher}
  \label{fig:service_dispatcher}
\end{figure}


To tackle this issue, we recommend introducing a \textit{service dispatcher} module to the current Ethereum stack at the P2P network level for handling incoming connection requests (in the distributed pool maintenance process) to forward the requests to the suitable local peer instance. Fig. \ref{fig:service_dispatcher} illustrates this new module, where the \textit{peer context} is the tuple of IP address and port exposed to remote peers, while the \textit{services contexts} represent locally deployed peer instances. Here, the \textit{IP address} is likely situated behind a network address translator, while the \textit{id} entry is being used to differentiate the various locally deployed peer instances and thus expose them correctly to the remote peers attempting to contact them. Based on our insights in Section \ref{sect:model}, we observe that up to $1800$, service instances may run atop a single peer, thus limiting the required context information to less than 100kBytes.

With the service dispatcher being a logical module, it can be deployed solely in so-called \textit{reachability points}, configured to deal with the expected load of incoming requests, while the peer instances may be deployed in a local sub-network (e.g., composed of several virtual machines in a cloud provider network). As shown in our insights of Section \ref{sect:impact}, adopting our recommendation in as few as ten infrastructures may reduce reachability issues in at least $86\%$ of the services in the system.

Our recommendation here aligns with similar developments in other Internet-based systems, most notably web servers, where similar dispatcher modules handle site-specific network mechanisms like DNS, triangulation, HTTP redirection, and URL rewriting \cite{Cardellini2002}, dispatching the individual web requests to logical web servers with $\approx 4500$ concurrent connections per second dispatching for $\approx 500$ clients \cite{Li2001}. The latter shows that our above-expected load of around $1800$ concurrent peer instances should be easily supported.

% Indeed, avoiding the tussles and issues \cite{Balduf2023} further introduced by approaches such as peer proxies \cite{Muehle2021}, concentrators \cite{Lee2020}, peer validators \cite{Dimitri2022}, and application level routers \cite{Trautwein2022}.

% \subsection{Gravity of Decentralization}
% As pointed out in Section \ref{sect:model}, peers running on well-known infrastructures show the DCS traffic and infrastructure concentration produced by less than $1\%$ of the infrastructures shape the system behavior.

% - For the DCS as a whole, this evolution represents a tradeoff: due to the traffic and infrastructure concentration around infrastructure providers, the DCS achieves higher availability, lower state diffusion, and consensus convergence latency; however, it gives up \textbf{decentralization} (i.e., its initial design premise when considering control of the underlay infrastructure), reachability, and therefore also network \textbf{resilience} for this.

% - Considering the high concentration, we observe failures for individual infrastructure providers that can result in significant outages of service instances, ranging from a maximum of $21\%$ to $4\%$ of the system that heavily impacts the state diffusion and consensus convergence latency, and most interestingly the time of \textit{continuous work on inconsistent state}, e.g., unsolved forks in chain of blocks \cite{Jin2019}.

\subsection{Location Guided Peer Selection}

The concentration evidence in Section \ref{sect:trend} sheds light on the \textit{bias towards few ISPs} when executing a random-based service selection.
Works in \cite{Thomas2023, Prasanna2004, Bless2022} recognized the same, albeit for different biases.
Salting the service ID generation or incorporating hierarchies and vicinity path lookups are approaches to bypassing such infrastructure bias in these related works. Hence, our recommendation aligns with that of utilizing salt in the process of the (Ethereum) service ID generation. This salted approach would allow taking into account the infrastructure concentration of services, although we recognize that further work is required to understand the whole nature of the used salt and to avoid biases towards small ISPs (infrastructures with few service instances).
% - to recall: randomized selection is biased towards top infra ISPs (1 sentence)

% - related work recognized this albeit for different biases (1 sentence)

% - We can see from related work that, to avoid top infra bias, salting the ID generation is the approach to take (1 sentence)

% - more work needed on (1) nature of the salt (ISP ID) and (2) avoidance of bias towards small ISPs (2 sentences)



%The initial conception for distributing content in a randomized approach \cite{Maymounkov2002} is rooted in the enhanced performance given by a lighter content replication and a quick content lookup in large scale infrastructures. However, DCSs, e.g., DLTs, rely on the full replication of the blockchain \cite{Nakamoto2008,Guzman2022} for partaking in the consensus.
%Hence, a location based peer selection for services such as transaction diffusion, and block replication (synchronization) which takes advantage of infrastructure clusters intuitively enhance the transaction and block diffusion, i.e., gossiping performance.

%This lookup and gossiping scheme taking advantage of clustering and locality has been proposed for other content platforms in \cite{Thomas2023,Bless2022} where the content lookup is enhanced in terms of peer hops required to find a block of information.

% Hence, we recommend exploring further approaches such as the ones in \cite{Guzman2023, Jin2019, Bless2022}, since in current systems, there is negligible churn and high availability of participants of the distributed consensus provided by the ease of cloud infrastructures.

% More specifically, given that the binary distance between service instance IDs is topologically independent, consolidation drive geographical bias towards those strong \textit{hosting infrastructures} \cite{Guzman2022}. Hence, we recommend a location guided selection of services to prevent collusion and further enhance the state diffusion delay.

\section{Conclusion}\label{sect:conclusion}

We described the growth, quantification, and orthogonal effects of the trend towards a service-centric model in existing Ethereum. Specifically, we quantified, based on emperical observations, the degree of reachability issues caused through this trend and the reasons behind those issues, chiefly the traffic and infrastructure consolidation through utilizing the hosting in cloud provider infrastructures. Our insights led to two concrete recommendations to reduce the observe non-reachability of deployed peers, while also tackling the impact of centralization in few cloud infrastructures on the convergence process. In future work, we envision quantifying the practical costs, implications, and benefits of implementing our recommendations at scale to guide DCS and DePIN designs.


\bibliographystyle{IEEEtranS}
\bibliography{bibliography,rfc}
\appendices
\section{}\label{app:b}
The tuning mechanisms such as short-timing the pool replenishment leads to high percentage of traffic in the consolidated infrastructures.
We describe the resulting traffic for a tuned discovery and connection establishment procedure.

\subsection{Pool Discovery}

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.28\textwidth]{image/bar_reqs_d_min_isp}
  \includegraphics[width=0.167\textwidth]{image/matrix_reqs_d_min_isp}
  \caption{(a) Density of Traffic arranged by Top 20 Infrastructures generating Traffic while Discovering the Network (b) $\%$ of Traffic along the Daytime relative to CET Time  }
  \label{fig:reqs_d_min_isp}
\end{figure}

In comparison to Fig.\ref{fig:bar_peers_services_isp} in Section \ref{sect:model}, we notice in the y-axis in Fig. \ref{fig:reqs_d_min_isp} that this is not in direct correspondence.
The top infrastructure requesting to discover the network (dGmH) differs from the leading infrastructure hosting most peers (HOGH).
This difference is due to different configurations for pool replenishment and a banning event reported in \cite{Hetzner2022,cointelegraph2022}.
As outlined before, short-timing the execution of discovery for a pool replenishment is the cause of this behavior.

\subsection{Pool Establishment}

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.28\textwidth]{image/bar_reqs_se_min_isp}
  \includegraphics[width=0.167\textwidth]{image/matrix_reqs_se_min_isp}
  \caption{a) Density of Traffic arranged by Top 20 Infrastructures generating Traffic while Establishing Connections (b) $\%$ of Traffic along the Daytime relative to CET Time}
  \label{fig:reqs_se_min_isp}
\end{figure}

We perform the identical comparison Fig. \ref{fig:bar_peers_services_isp} in Section \ref{sect:model} against Fig. \ref{fig:reqs_se_min_isp} for connection establishments.
For example, HOGH is the top hosting infrastructure. Still, CVPN is the one establishing the most connections, as shown in Fig. \ref{fig:reqs_se_min_isp}, achieved by faster pool replenishment. This behavior for this infrastructure is also reported in \cite{Binance2023} for Bitcoin.

% 1 Amazon Technologies Inc.             13156. 149.
%  2 Amazon Data Services NoVa            12421. 100.
%  3 Amazon Data Services Ireland Limited  7392.  84.7
%  4 DigitalOcean LLC                      3330.  72.2
%  5 Amazon.com Inc.                       3237.  61.6
%  6 Hetzner Online GmbH                   3056.  81.5
%  7 Amazon Data Services Japan            2516.  80.7
%  8 OVH SAS                               1053.  45.2
%  9 Contabo GmbH                          1053.  29.4
% 10 Google LLC                            1047.  34.9

% isp                                  incoming in_perc
% <chr>                                   <int>   <dbl>
% 1 Amazon Technologies Inc.               789389   21.1
% 2 Amazon Data Services NoVa              745236   19.9
% 3 Amazon Data Services Ireland Limited   443507   11.8
% 4 DigitalOcean LLC                       199778    5.33
% 5 Amazon.com Inc.                        194202    5.18
% 6 Hetzner Online GmbH                    183372    4.89
% 7 Amazon Data Services Japan             150988    4.03
% 8 OVH SAS                                 63204    1.69
% 9 Contabo GmbH                            63165    1.69
% 10 Google LLC                              62836    1.68

\end{document}
